/* Copyright 1991 NEC Corporation, Tokyo, Japan.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of NEC Corporation
 * not be used in advertising or publicity pertaining to distribution
 * of the software without specific, written prior permission.  NEC 
 * Corporation makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express
 * or implied warranty.
 *
 * NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN 
 * NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR 
 * OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR 
 * PERFORMANCE OF THIS SOFTWARE. 
 */

static char bunmap_id[] = "@(#) 102.1 $Header: /raf/groo/devel/home/arpa/src/canna/RCS/bunmap.c,v 1.1 1995/01/05 21:43:12 devel Exp $";

extern DoFuncSequence(),UseOtherKeymap();

#define NONE IROHA_FN_Undefined

static int (*bun_funcs[])() = {
/* ̤                           */    NONE,
/* ʬȤؿ           */    NONE,
/* ʤؿ         */    BunSelfInsert,
/* 			    */    BunQuotedInsert,
/* ܸϥ⡼                 */    NONE,
/* ե٥åϥ⡼         */    NONE,
/* Ѵϥ⡼                   */    NONE,
/* ѤҤ餬ʳϥ⡼       */    NONE,
/* ѥʳϥ⡼       */    NONE,
/* Ⱦѥʳϥ⡼       */    NONE,
/* ѥե٥åȳϥ⡼ */    NONE,
/* Ⱦѥե٥åȳϥ⡼ */    NONE,
/* ϥ⡼		    */    NONE,
/* ϥ⡼		    */    NONE,
/* ϥ⡼		    */    NONE,
/*                              */    BunExtend,
/*                              */    BunShrink,
/* ι                           */    NONE,
/* ι                           */    NONE,
/* Ƭ                             */    BunFullShrink,
/*                              */    BunFullExtend,
/*                        */    BunQuit,
/* ˺                         */    BunQuit,
/* ޤǺ                     */    BunKillToEOL,
/* Ѵ                             */    BunHenkan,
/*                              */    BunKakutei,
/* Ф                           */    BunExtend,
/* ̤                             */    BunShrink,
/* ʸ῭̥⡼ɤ                 */    NONE, 		   
/*                          */    BunQuit,
/* Ͽ                             */    NONE,
/* ʥɤȤѴ           */    NONE,
/* ̾ȤѴ                 */    NONE,
/*                          */    NONE,
/* ʬ̵Ѵ                       */    NONE,
/* ѤؤѴ                     */    NONE,
/* ȾѤؤѴ                     */    NONE,
/* ʸؤѴ                   */    NONE,
/* ԥ饤                   */    NONE,
/* ʸؤѴ                   */    NONE,
/* Ҥ餬Ѵ			    */	  NONE,
/* Ѵ			    */	  NONE,
/* ޻Ѵ			    */	  NONE,
/* ʣΥγ             */    DoFuncSequence,
/* 󥹤ؤб           */    UseOtherKeymap,
};

KanjiModeRec bunsetsu_mode = {
  simplefunc,
  default_kmap,
  IROHA_KANJIMODE_TABLE_SHARED,
  bun_funcs,
};

