extern char *malloc(), *realloc();

# line 26 "gram.y"
static char rcs_id[]=
  "@(#) 102.1 $Header: /raf/groo/devel/home/arpa/src/canna/RCS/gram.c,v 1.1 1995/01/05 21:43:12 devel Exp $";

#include "iroha.h"
#include <iroha/mfdef.h>

#define PREVK 3
#define NEXTK 2
#define YES 1
#define NO  0

static char *ptr;
static unsigned char actbuff[256],keybuff[128];
static int special = NO;
static int mode, localmode = NO;
static int firstKey, i = 0, j = 0;
extern InitialMode, CursorWrap, SelectDirect;
extern HexkeySelect, Gakushu, BreakIntoRoman, BunsetsuKugiri;
extern QuitIchiranIfEnd, stayAfterValidate, kakuteiIfEndOfBunsetsu;
extern kouho_threshold, gramaticalQuestion, forceKana, kCount;
extern iListCB;
extern char *RomkanaTable, *RengoGakushu, *KatakanaGakushu;
extern char IROHA_rcfilename[];

extern int yylineno;

# line 53 "gram.y"
typedef union 
{
    int num;
    char *ptr;
} YYSTYPE;
# define LB 257
# define RB 258
# define LP 259
# define RP 260
# define KEY 261
# define NEWLINE 262
# define COMMA 263
# define ROMKANATABLE 264
# define INITIALMODE 265
# define HENKANNYURYOKUMODE 266
# define ZENHIRAHENKANMODE 267
# define ZENKATAHENKANMODE 268
# define ZENALPHAHENKANMODE 269
# define HANKATAHENKANMODE 270
# define HANALPHAHENKANMODE 271
# define ZENHIRAKAKUTEIMODE 272
# define ZENKATAKAKUTEIMODE 273
# define ZENALPHAKAKUTEIMODE 274
# define HANKATAKAKUTEIMODE 275
# define HANALPHAKAKUTEIMODE 276
# define BUNSETSUKUGIRI 277
# define CURSORWRAP 278
# define ON_FLAG 279
# define OFF_FLAG 280
# define SELECTEDIRECT 281
# define DICTIONARY 282
# define USERDIC 283
# define BUSHUDIC 284
# define RENGODIC 285
# define KANADIC 286
# define LOCALDIC 287
# define CHARACTERBASEDMOVE 288
# define REVERSEWIDELY 289
# define GAKUSHU 290
# define BREAKINTOROMAN 291
# define QUITIFENDOFICHIRAN 292
# define ALPHAMODE 293
# define QUOTEDINSERT 294
# define KAKUTEI 295
# define EXTEND 296
# define SHRINK 297
# define SHINSHUKU 298
# define TOUROKU 299
# define FORWARD 300
# define BACKWARD 301
# define PREVIOUS 302
# define NEXT 303
# define BEGINNINGOFLINE 304
# define ENDOFLINE 305
# define DELETENEXT 306
# define DELETEPREVIOUS 307
# define KILLTOENDOFLINE 308
# define HENKAN 309
# define QUIT 310
# define SELFINSERT 311
# define ALPHA 312
# define JAPANESEMODE 313
# define YOMIGANAI 314
# define HEXMODE 315
# define BUSHUMODE 316
# define KIGOUMODE 317
# define YOMI 318
# define NEXTCHARACTERSET 319
# define PREVCHARACTERSET 320
# define CONVERTASHEX 321
# define CONVERTASBUSHU 322
# define MOJISHU 323
# define ZENKAKU 324
# define HANKAKU 325
# define TOUPPER 326
# define CAPITALIZE 327
# define TOLOWER 328
# define TANKOUHO 329
# define MUHENKAN 330
# define NEXTKOUHO 331
# define PREVKOUHO 332
# define KOUHOICHIRAN 333
# define BUBUNMUHENKAN 334
# define ICHIRAN 335
# define PREVKOUHORETSU 336
# define NEXTKOUHORETSU 337
# define BEGINNINGOFKOUHO 338
# define ENDOFKOUHO 339
# define KAKUTEINYURYOKU 340
# define EXTENDMODE 341
# define HEX 342
# define BUSHU 343
# define HENKANNYURYOKU 344
# define ZENHIRAKAKUTEI 345
# define ZENKATAKAKUTEI 346
# define ZENALPHAKAKUTEI 347
# define HANKATAKAKUTEI 348
# define HANALPHAKAKUTEI 349
# define SELECTDIRECT 350
# define HEXKEYSELECT 351
# define MODESTRING 352
# define STAYAFTERVALIDATE 353
# define KAKUTEIIFENDOFBUNSETSU 354
# define HIRAGANA 355
# define KATAKANA 356
# define ROMAJI 357
# define NHENKANFORICHIRAN 358
# define NUMBER 359
# define KIGO 360
# define YESNO 361
# define RUSSIAN 362
# define GREEK 363
# define LINE 364
# define CHANGINGSERVER 365
# define HENKANMETHOD 366
# define DELETEDIC 367
# define TOUROKUHINSHI 368
# define TOUROKUDIC 369
# define ZENKATAHENKAN 370
# define ZENALPHAHENKAN 371
# define HANKATAHENKAN 372
# define HANALPHAHENKAN 373
# define MOUNTDIC 374
# define GRAMATICALQUESTION 375
# define FORCEKANA 376
# define KOUHOCOUNT 377
# define INHIBITLISTCALLBACK 378
# define STRING 379
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 506 "gram.y"

extern IROHA_ParseError;

static
yyerror(s)
char *s;
{
   char buf[256];
   void addWarningMesg();

   sprintf(buf, "%s: syntax error, line %d", IROHA_rcfilename, yylineno);
   addWarningMesg(buf);
   IROHA_ParseError = 1;
}

static
RemoveDblQuote(str)
char *str;
{
    strcpy(str, &str[1]);
    str[strlen(str)-1] = '\0';
}

static
chgKeyfunc(key, fnum)
int key, fnum;
{
    if (localmode)
      changeKeyfunc(mode, key, fnum, actbuff, keybuff);
    else
      changeKeyfuncOfAll(key, fnum, actbuff, keybuff);
}
int yyexca[] ={
-1, 0,
	0, 2,
	262, 2,
	-2, 0,
-1, 1,
	0, -1,
	-2, 0,
-1, 42,
	257, 109,
	-2, 133,
-1, 98,
	0, 110,
	-2, 0,
	};
# define YYNPROD 171
# define YYLAST 683
int yyact[]={

     4,   101,   116,   117,   207,    29,   160,   135,     5,     6,
    88,   158,   257,   157,    99,   160,    89,    90,    92,    91,
    93,    10,     7,   256,   255,   254,    11,    12,    13,    15,
    16,    14,    17,    18,    19,    23,    20,    83,    62,    57,
    59,    58,    42,    63,    47,    48,    50,    49,    51,    52,
    53,    54,    55,    56,    60,    61,    30,    84,    31,    85,
    86,    87,    32,    65,    66,    67,    68,    33,    69,    70,
    71,    72,    73,    34,    74,    75,    76,    77,    78,    35,
    80,    79,    81,    82,   253,    64,   252,   251,    36,    37,
    38,    39,    40,    41,     8,     9,    43,    22,    21,    94,
    95,    96,    24,   250,   249,   136,   248,     4,   247,   246,
   245,   156,   244,   243,   242,     5,     6,    88,   241,    25,
    26,    27,    28,    89,    90,    92,    91,    93,    10,     7,
   240,   239,   238,    11,    12,    13,    15,    16,    14,    17,
    18,    19,    23,    20,    83,    62,    57,    59,    58,    42,
    63,    47,    48,    50,    49,    51,    52,    53,    54,    55,
    56,    60,    61,    30,    84,    31,    85,    86,    87,    32,
    65,    66,    67,    68,    33,    69,    70,    71,    72,    73,
    34,    74,    75,    76,    77,    78,    35,    80,    79,    81,
    82,   237,    64,   236,   235,    36,    37,    38,    39,    40,
    41,     8,     9,    43,    22,    21,    94,    95,    96,    24,
   160,   234,   233,   232,    88,   231,   230,   229,   228,   227,
    89,    90,    92,    91,    93,   226,    25,    26,    27,    28,
   225,   224,   142,   155,   294,    98,   211,    46,    45,    44,
   258,    83,    62,    57,    59,    58,   209,    63,    47,    48,
    50,    49,    51,    52,    53,    54,    55,    56,    60,    61,
   173,    84,   172,    85,    86,    87,     3,    65,    66,    67,
    68,   171,    69,    70,    71,    72,    73,   170,    74,    75,
    76,    77,    78,   169,    80,    79,    81,    82,    88,    64,
   168,   167,   166,   165,    89,    90,    92,    91,    93,   295,
   164,   163,   162,    94,    95,    96,   161,     2,   210,     1,
   134,   102,     0,     0,     0,    83,    62,    57,    59,    58,
   209,    63,    47,    48,    50,    49,    51,    52,    53,    54,
    55,    56,    60,    61,     0,    84,     0,    85,    86,    87,
     0,    65,    66,    67,    68,     0,    69,    70,    71,    72,
    73,     0,    74,    75,    76,    77,    78,   100,    80,    79,
    81,    82,   200,    64,   190,   159,   184,   197,     0,   121,
   122,   123,   124,   125,   126,     0,     0,    94,    95,    96,
   174,     0,   175,     0,     0,     0,     0,     0,     0,     0,
     0,   186,     0,     0,     0,   208,     0,   187,     0,     0,
     0,     0,   201,   188,     0,     0,     0,     0,     0,     0,
   176,   177,   178,   179,   180,   181,   182,   183,     0,     0,
     0,     0,     0,    97,     0,     0,     0,     0,   185,   189,
   191,   192,   193,   194,   195,   196,   198,   199,   202,   204,
   203,   205,   206,   103,   104,   105,   107,   106,   108,   109,
   110,   111,   112,   113,   141,   143,   144,   145,   146,   147,
   148,   149,   150,   151,   152,   153,   154,     0,     0,     0,
   114,   212,   213,   214,   215,   216,   217,   218,   219,   220,
   221,   222,   223,   115,     0,     0,     0,     0,     0,     0,
     0,   293,   118,   119,   120,     0,     0,     0,     0,     0,
     0,   127,   128,   129,   130,   131,   132,   133,     0,   137,
   138,   139,   140,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   259,   260,   261,   262,   263,   264,   265,   266,
   267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
   287,   288,   289,   290,   291,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   292 };
int yypact[]={

  -149, -1000,  -248, -1000, -1000,  -378,   177,  -277,  -277,  -277,
  -277,  -378,  -378,  -378,  -378,  -378,  -378,  -277,  -277,  -277,
  -277,  -277,  -277,  -277,  -254,  -277,  -277,  -277,  -277, -1000,
  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,
  -248,  -248,  -248,   -26, -1000,  -250, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,  -256, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000,  -247, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,    68,  -259,    22, -1000, -1000,
 -1000,   -21,   -21,   -21,   -21,   -21,   -21,   -21,   -21,   -21,
   -21,   -21,   -21,   -21,   -29,   -30,   -35,   -41,   -42,   -43,
   -44,   -45,   -47,   -48,   -49,   -66,   -67,   -69,  -128,  -129,
  -130,  -142,  -146,  -147,  -148,  -150,  -151,  -152,  -154,  -156,
  -157,  -173,  -174,  -176,  -235,  -236,  -237,  -249, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000,  -378,  -378,  -378,  -378,  -378,  -378,
  -378,  -378,  -378,  -378,  -378,  -378,  -378,  -378,  -378,  -378,
  -378,  -378,  -378,  -378,  -378,  -378,  -378,  -378,  -378,  -378,
  -378,  -378,  -378,  -378,  -378,  -378,  -378, -1000,  -248, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000,   -24,   -52, -1000, -1000 };
int yypgo[]={

     0,   357,   311,   483,   310,   309,   307,   423,   266,   232,
     5,   306,   308,   302,   301,   300,   293,   292,   291,   290,
   283,   277,   271,   262,   260,   240,   239,   238,   111,   237 };
int yyr1[]={

     0,     5,     6,     6,     6,     8,     8,     8,     8,     8,
     8,     8,     8,     8,     8,     8,     8,     8,     8,     8,
     8,     8,     8,     8,     8,     8,     8,     8,     8,     8,
     8,     8,    11,     8,    13,     8,    14,     8,    15,     8,
    16,     8,    17,     8,    18,     8,    19,     8,    20,     8,
    21,     8,    22,     8,    23,     8,    24,     8,     8,     8,
     8,     8,     8,     8,     8,     8,     8,     8,     8,     8,
     8,     8,     8,     8,     8,     8,     8,     8,     8,     8,
     8,     8,     8,     8,     8,     8,     8,     8,     8,     8,
     8,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     3,     3,     4,     1,     9,     9,     7,
     7,    12,    25,    25,    10,    26,    27,    27,    28,    28,
    29,    29,    29,    29,    29,    29,    29,    29,    29,    29,
    29,    29,    29,    29,    29,    29,    29,    29,    29,    29,
    29,    29,    29,    29,    29,    29,    29,    29,    29,    29,
    29,    29,    29,    29,    29,    29,    29,    29,    29,    29,
    29,    29,    29,    29,    29,    29,    29,    29,    29,    29,
    29 };
int yyr2[]={

     0,     4,     0,     2,     6,     2,     5,     5,     5,     5,
     5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
     5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
     5,     2,     1,     9,     1,     9,     1,     9,     1,     9,
     1,     9,     1,     9,     1,     9,     1,     9,     1,     9,
     1,     9,     1,     9,     1,     9,     1,     9,    11,    11,
    11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
    11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
    11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
    11,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     2,     2,     2,     3,     2,     4,     0,
     2,     8,     0,     6,     2,     5,     2,     6,     3,     7,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3 };
int yychk[]={

 -1000,    -5,    -6,    -8,   256,   264,   265,   278,   350,   351,
   277,   282,   283,   284,   287,   285,   286,   288,   289,   290,
   292,   354,   353,   291,   358,   375,   376,   377,   378,   -10,
   312,   314,   318,   323,   329,   335,   344,   345,   346,   347,
   348,   349,   298,   352,   -26,   -27,   -29,   300,   301,   303,
   302,   304,   305,   306,   307,   308,   309,   295,   297,   296,
   310,   311,   294,   299,   341,   319,   320,   321,   322,   324,
   325,   326,   327,   328,   330,   331,   332,   333,   334,   337,
   336,   338,   339,   293,   313,   315,   316,   317,   266,   272,
   273,   275,   274,   276,   355,   356,   357,    -7,    -9,   262,
    -1,   379,    -2,   266,   267,   268,   270,   269,   271,   272,
   273,   274,   275,   276,   293,    -3,   279,   280,    -3,    -3,
    -3,    -1,    -1,    -1,    -1,    -1,    -1,    -3,    -3,    -3,
    -3,    -3,    -3,    -3,    -4,   261,   359,    -3,    -3,    -3,
    -3,    -7,    -9,    -7,    -7,    -7,    -7,    -7,    -7,    -7,
    -7,    -7,    -7,    -7,    -7,   259,   -28,   263,   261,    -8,
   262,   -11,   -13,   -14,   -15,   -16,   -17,   -18,   -19,   -20,
   -21,   -22,   -23,   -24,   312,   314,   342,   343,   344,   345,
   346,   347,   348,   349,   298,   360,   323,   329,   335,   361,
   296,   362,   363,   364,   365,   366,   367,   299,   368,   369,
   294,   334,   370,   372,   371,   373,   374,   263,   -29,   298,
   -12,   257,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
   -12,   -12,   -12,   -12,   260,   260,   260,   260,   260,   260,
   260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
   260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
   260,   260,   260,   260,   260,   260,   260,   261,   -25,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -7,    -9,   258,   -10 };
int yydef[]={

    -2,    -2,   109,     3,     5,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    31,
   109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
   109,   109,    -2,     0,   114,     0,   116,   120,   121,   122,
   123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
   134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
   144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
   154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
   164,   165,   166,   167,   168,   169,   170,     1,    -2,   107,
     6,   106,     7,    91,    92,    93,    94,    95,    96,    97,
    98,    99,   100,   101,   102,     8,   103,   104,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,   105,    27,    28,    29,
    30,    32,   110,    34,    36,    38,    40,    42,    44,    46,
    48,    50,    52,    54,    56,     0,   115,     0,   118,     4,
   108,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   117,   133,
    33,   112,    35,    37,    39,    41,    43,    45,    47,    49,
    51,    53,    55,    57,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   119,   109,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,     0,   110,   111,   113 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"LB",	257,
	"RB",	258,
	"LP",	259,
	"RP",	260,
	"KEY",	261,
	"NEWLINE",	262,
	"COMMA",	263,
	"ROMKANATABLE",	264,
	"INITIALMODE",	265,
	"HENKANNYURYOKUMODE",	266,
	"ZENHIRAHENKANMODE",	267,
	"ZENKATAHENKANMODE",	268,
	"ZENALPHAHENKANMODE",	269,
	"HANKATAHENKANMODE",	270,
	"HANALPHAHENKANMODE",	271,
	"ZENHIRAKAKUTEIMODE",	272,
	"ZENKATAKAKUTEIMODE",	273,
	"ZENALPHAKAKUTEIMODE",	274,
	"HANKATAKAKUTEIMODE",	275,
	"HANALPHAKAKUTEIMODE",	276,
	"BUNSETSUKUGIRI",	277,
	"CURSORWRAP",	278,
	"ON_FLAG",	279,
	"OFF_FLAG",	280,
	"SELECTEDIRECT",	281,
	"DICTIONARY",	282,
	"USERDIC",	283,
	"BUSHUDIC",	284,
	"RENGODIC",	285,
	"KANADIC",	286,
	"LOCALDIC",	287,
	"CHARACTERBASEDMOVE",	288,
	"REVERSEWIDELY",	289,
	"GAKUSHU",	290,
	"BREAKINTOROMAN",	291,
	"QUITIFENDOFICHIRAN",	292,
	"ALPHAMODE",	293,
	"QUOTEDINSERT",	294,
	"KAKUTEI",	295,
	"EXTEND",	296,
	"SHRINK",	297,
	"SHINSHUKU",	298,
	"TOUROKU",	299,
	"FORWARD",	300,
	"BACKWARD",	301,
	"PREVIOUS",	302,
	"NEXT",	303,
	"BEGINNINGOFLINE",	304,
	"ENDOFLINE",	305,
	"DELETENEXT",	306,
	"DELETEPREVIOUS",	307,
	"KILLTOENDOFLINE",	308,
	"HENKAN",	309,
	"QUIT",	310,
	"SELFINSERT",	311,
	"ALPHA",	312,
	"JAPANESEMODE",	313,
	"YOMIGANAI",	314,
	"HEXMODE",	315,
	"BUSHUMODE",	316,
	"KIGOUMODE",	317,
	"YOMI",	318,
	"NEXTCHARACTERSET",	319,
	"PREVCHARACTERSET",	320,
	"CONVERTASHEX",	321,
	"CONVERTASBUSHU",	322,
	"MOJISHU",	323,
	"ZENKAKU",	324,
	"HANKAKU",	325,
	"TOUPPER",	326,
	"CAPITALIZE",	327,
	"TOLOWER",	328,
	"TANKOUHO",	329,
	"MUHENKAN",	330,
	"NEXTKOUHO",	331,
	"PREVKOUHO",	332,
	"KOUHOICHIRAN",	333,
	"BUBUNMUHENKAN",	334,
	"ICHIRAN",	335,
	"PREVKOUHORETSU",	336,
	"NEXTKOUHORETSU",	337,
	"BEGINNINGOFKOUHO",	338,
	"ENDOFKOUHO",	339,
	"KAKUTEINYURYOKU",	340,
	"EXTENDMODE",	341,
	"HEX",	342,
	"BUSHU",	343,
	"HENKANNYURYOKU",	344,
	"ZENHIRAKAKUTEI",	345,
	"ZENKATAKAKUTEI",	346,
	"ZENALPHAKAKUTEI",	347,
	"HANKATAKAKUTEI",	348,
	"HANALPHAKAKUTEI",	349,
	"SELECTDIRECT",	350,
	"HEXKEYSELECT",	351,
	"MODESTRING",	352,
	"STAYAFTERVALIDATE",	353,
	"KAKUTEIIFENDOFBUNSETSU",	354,
	"HIRAGANA",	355,
	"KATAKANA",	356,
	"ROMAJI",	357,
	"NHENKANFORICHIRAN",	358,
	"NUMBER",	359,
	"KIGO",	360,
	"YESNO",	361,
	"RUSSIAN",	362,
	"GREEK",	363,
	"LINE",	364,
	"CHANGINGSERVER",	365,
	"HENKANMETHOD",	366,
	"DELETEDIC",	367,
	"TOUROKUHINSHI",	368,
	"TOUROKUDIC",	369,
	"ZENKATAHENKAN",	370,
	"ZENALPHAHENKAN",	371,
	"HANKATAHENKAN",	372,
	"HANALPHAHENKAN",	373,
	"MOUNTDIC",	374,
	"GRAMATICALQUESTION",	375,
	"FORCEKANA",	376,
	"KOUHOCOUNT",	377,
	"INHIBITLISTCALLBACK",	378,
	"STRING",	379,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"cookrc : stmts newlines",
	"stmts : /* empty */",
	"stmts : stmt",
	"stmts : stmts newline stmt",
	"stmt : error",
	"stmt : ROMKANATABLE string",
	"stmt : INITIALMODE initMode",
	"stmt : CURSORWRAP flag",
	"stmt : SELECTDIRECT flag",
	"stmt : HEXKEYSELECT flag",
	"stmt : BUNSETSUKUGIRI flag",
	"stmt : DICTIONARY string",
	"stmt : USERDIC string",
	"stmt : BUSHUDIC string",
	"stmt : LOCALDIC string",
	"stmt : RENGODIC string",
	"stmt : KANADIC string",
	"stmt : CHARACTERBASEDMOVE flag",
	"stmt : REVERSEWIDELY flag",
	"stmt : GAKUSHU flag",
	"stmt : QUITIFENDOFICHIRAN flag",
	"stmt : KAKUTEIIFENDOFBUNSETSU flag",
	"stmt : STAYAFTERVALIDATE flag",
	"stmt : BREAKINTOROMAN flag",
	"stmt : NHENKANFORICHIRAN number",
	"stmt : NHENKANFORICHIRAN KEY",
	"stmt : GRAMATICALQUESTION flag",
	"stmt : FORCEKANA flag",
	"stmt : KOUHOCOUNT flag",
	"stmt : INHIBITLISTCALLBACK flag",
	"stmt : keymapping",
	"stmt : ALPHA newlines",
	"stmt : ALPHA newlines keymappingList",
	"stmt : YOMIGANAI newlines",
	"stmt : YOMIGANAI newlines keymappingList",
	"stmt : YOMI newlines",
	"stmt : YOMI newlines keymappingList",
	"stmt : MOJISHU newlines",
	"stmt : MOJISHU newlines keymappingList",
	"stmt : TANKOUHO newlines",
	"stmt : TANKOUHO newlines keymappingList",
	"stmt : ICHIRAN newlines",
	"stmt : ICHIRAN newlines keymappingList",
	"stmt : HENKANNYURYOKU newlines",
	"stmt : HENKANNYURYOKU newlines keymappingList",
	"stmt : ZENHIRAKAKUTEI newlines",
	"stmt : ZENHIRAKAKUTEI newlines keymappingList",
	"stmt : ZENKATAKAKUTEI newlines",
	"stmt : ZENKATAKAKUTEI newlines keymappingList",
	"stmt : ZENALPHAKAKUTEI newlines",
	"stmt : ZENALPHAKAKUTEI newlines keymappingList",
	"stmt : HANKATAKAKUTEI newlines",
	"stmt : HANKATAKAKUTEI newlines keymappingList",
	"stmt : HANALPHAKAKUTEI newlines",
	"stmt : HANALPHAKAKUTEI newlines keymappingList",
	"stmt : SHINSHUKU newlines",
	"stmt : SHINSHUKU newlines keymappingList",
	"stmt : MODESTRING LP ALPHA RP string",
	"stmt : MODESTRING LP YOMIGANAI RP string",
	"stmt : MODESTRING LP HEX RP string",
	"stmt : MODESTRING LP BUSHU RP string",
	"stmt : MODESTRING LP HENKANNYURYOKU RP string",
	"stmt : MODESTRING LP ZENHIRAKAKUTEI RP string",
	"stmt : MODESTRING LP ZENKATAKAKUTEI RP string",
	"stmt : MODESTRING LP ZENALPHAKAKUTEI RP string",
	"stmt : MODESTRING LP HANKATAKAKUTEI RP string",
	"stmt : MODESTRING LP HANALPHAKAKUTEI RP string",
	"stmt : MODESTRING LP SHINSHUKU RP string",
	"stmt : MODESTRING LP KIGO RP string",
	"stmt : MODESTRING LP MOJISHU RP string",
	"stmt : MODESTRING LP TANKOUHO RP string",
	"stmt : MODESTRING LP ICHIRAN RP string",
	"stmt : MODESTRING LP YESNO RP string",
	"stmt : MODESTRING LP EXTEND RP string",
	"stmt : MODESTRING LP RUSSIAN RP string",
	"stmt : MODESTRING LP GREEK RP string",
	"stmt : MODESTRING LP LINE RP string",
	"stmt : MODESTRING LP CHANGINGSERVER RP string",
	"stmt : MODESTRING LP HENKANMETHOD RP string",
	"stmt : MODESTRING LP DELETEDIC RP string",
	"stmt : MODESTRING LP TOUROKU RP string",
	"stmt : MODESTRING LP TOUROKUHINSHI RP string",
	"stmt : MODESTRING LP TOUROKUDIC RP string",
	"stmt : MODESTRING LP QUOTEDINSERT RP string",
	"stmt : MODESTRING LP BUBUNMUHENKAN RP string",
	"stmt : MODESTRING LP ZENKATAHENKAN RP string",
	"stmt : MODESTRING LP HANKATAHENKAN RP string",
	"stmt : MODESTRING LP ZENALPHAHENKAN RP string",
	"stmt : MODESTRING LP HANALPHAHENKAN RP string",
	"stmt : MODESTRING LP MOUNTDIC RP string",
	"initMode : HENKANNYURYOKUMODE",
	"initMode : ZENHIRAHENKANMODE",
	"initMode : ZENKATAHENKANMODE",
	"initMode : HANKATAHENKANMODE",
	"initMode : ZENALPHAHENKANMODE",
	"initMode : HANALPHAHENKANMODE",
	"initMode : ZENHIRAKAKUTEIMODE",
	"initMode : ZENKATAKAKUTEIMODE",
	"initMode : ZENALPHAKAKUTEIMODE",
	"initMode : HANKATAKAKUTEIMODE",
	"initMode : HANALPHAKAKUTEIMODE",
	"initMode : ALPHAMODE",
	"flag : ON_FLAG",
	"flag : OFF_FLAG",
	"number : NUMBER",
	"string : STRING",
	"newline : NEWLINE",
	"newline : newline NEWLINE",
	"newlines : /* empty */",
	"newlines : newline",
	"keymappingList : LB keymappings newlines RB",
	"keymappings : /* empty */",
	"keymappings : keymappings newline keymapping",
	"keymapping : seq",
	"seq : acts keys",
	"acts : act",
	"acts : acts COMMA act",
	"keys : KEY",
	"keys : keys COMMA KEY",
	"act : FORWARD",
	"act : BACKWARD",
	"act : NEXT",
	"act : PREVIOUS",
	"act : BEGINNINGOFLINE",
	"act : ENDOFLINE",
	"act : DELETENEXT",
	"act : DELETEPREVIOUS",
	"act : KILLTOENDOFLINE",
	"act : HENKAN",
	"act : KAKUTEI",
	"act : SHRINK",
	"act : EXTEND",
	"act : SHINSHUKU",
	"act : QUIT",
	"act : SELFINSERT",
	"act : QUOTEDINSERT",
	"act : TOUROKU",
	"act : EXTENDMODE",
	"act : NEXTCHARACTERSET",
	"act : PREVCHARACTERSET",
	"act : CONVERTASHEX",
	"act : CONVERTASBUSHU",
	"act : ZENKAKU",
	"act : HANKAKU",
	"act : TOUPPER",
	"act : CAPITALIZE",
	"act : TOLOWER",
	"act : MUHENKAN",
	"act : NEXTKOUHO",
	"act : PREVKOUHO",
	"act : KOUHOICHIRAN",
	"act : BUBUNMUHENKAN",
	"act : NEXTKOUHORETSU",
	"act : PREVKOUHORETSU",
	"act : BEGINNINGOFKOUHO",
	"act : ENDOFKOUHO",
	"act : ALPHAMODE",
	"act : JAPANESEMODE",
	"act : HEXMODE",
	"act : BUSHUMODE",
	"act : KIGOUMODE",
	"act : HENKANNYURYOKUMODE",
	"act : ZENHIRAKAKUTEIMODE",
	"act : ZENKATAKAKUTEIMODE",
	"act : HANKATAKAKUTEIMODE",
	"act : ZENALPHAKAKUTEIMODE",
	"act : HANALPHAKAKUTEIMODE",
	"act : HIRAGANA",
	"act : KATAKANA",
	"act : ROMAJI",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 6:
# line 115 "gram.y"
{ RomkanaTable = yypvt[-0].ptr; } break;
case 7:
# line 116 "gram.y"
{ InitialMode = yypvt[-0].num; } break;
case 8:
# line 117 "gram.y"
{ CursorWrap = yypvt[-0].num; } break;
case 9:
# line 118 "gram.y"
{ SelectDirect = yypvt[-0].num; } break;
case 10:
# line 119 "gram.y"
{ HexkeySelect = yypvt[-0].num; } break;
case 11:
# line 120 "gram.y"
{ BunsetsuKugiri = yypvt[-0].num; } break;
case 12:
# line 121 "gram.y"
{ 
			kanjidicname[nkanjidics++] = yypvt[-0].ptr;
			kanjidicname[nkanjidics] = NULL; } break;
case 13:
# line 124 "gram.y"
{
			userdicname[nuserdics++] = yypvt[-0].ptr;
			userdicname[nuserdics] = NULL; } break;
case 14:
# line 127 "gram.y"
{
			bushudicname[nbushudics++] = yypvt[-0].ptr;
			bushudicname[nbushudics] = NULL; } break;
case 15:
# line 130 "gram.y"
{
			localdicname[nlocaldics++] = yypvt[-0].ptr;
			localdicname[nlocaldics] = NULL; } break;
case 16:
# line 133 "gram.y"
{ RengoGakushu = yypvt[-0].ptr; } break;
case 17:
# line 134 "gram.y"
{ KatakanaGakushu = yypvt[-0].ptr; } break;
case 18:
# line 135 "gram.y"
{ setIchitaroMove(!yypvt[-0].num); } break;
case 19:
# line 136 "gram.y"
{ setReverseOnlyCursor(!yypvt[-0].num); } break;
case 20:
# line 137 "gram.y"
{ Gakushu = yypvt[-0].num; } break;
case 21:
# line 138 "gram.y"
{ QuitIchiranIfEnd = yypvt[-0].num; } break;
case 22:
# line 139 "gram.y"
{ kakuteiIfEndOfBunsetsu = yypvt[-0].num; } break;
case 23:
# line 140 "gram.y"
{ stayAfterValidate = yypvt[-0].num; } break;
case 24:
# line 141 "gram.y"
{ BreakIntoRoman = yypvt[-0].num; } break;
case 25:
# line 142 "gram.y"
{ kouho_threshold = yypvt[-0].num; } break;
case 26:
# line 143 "gram.y"
{
			if ('0' <= yypvt[-0].num && yypvt[-0].num <= '9') {
			  kouho_threshold = yypvt[-0].num - '0';
			}
			else {
			  yyerror(IROHA_rcfilename);
			} } break;
case 27:
# line 150 "gram.y"
{ gramaticalQuestion = yypvt[-0].num; } break;
case 28:
# line 151 "gram.y"
{ forceKana = yypvt[-0].num; } break;
case 29:
# line 152 "gram.y"
{ kCount = yypvt[-0].num; } break;
case 30:
# line 153 "gram.y"
{ iListCB = yypvt[-0].num; } break;
case 32:
# line 157 "gram.y"
{ localmode = YES; mode = IROHA_MODE_AlphaMode; } break;
case 33:
# line 159 "gram.y"
{ localmode = NO; } break;
case 34:
# line 162 "gram.y"
{ localmode = YES; mode = IROHA_MODE_EmptyMode; } break;
case 35:
# line 164 "gram.y"
{ localmode = NO; } break;
case 36:
# line 167 "gram.y"
{ localmode = YES; mode = IROHA_MODE_YomiMode; } break;
case 37:
# line 169 "gram.y"
{ localmode = NO; } break;
case 38:
# line 172 "gram.y"
{ localmode = YES; mode = IROHA_MODE_JishuMode; } break;
case 39:
# line 174 "gram.y"
{ localmode = NO; } break;
case 40:
# line 177 "gram.y"
{ localmode = YES; mode = IROHA_MODE_TankouhoMode; } break;
case 41:
# line 179 "gram.y"
{ localmode = NO; } break;
case 42:
# line 182 "gram.y"
{ localmode = YES; mode = IROHA_MODE_IchiranMode; } break;
case 43:
# line 184 "gram.y"
{ localmode = NO; } break;
case 44:
# line 187 "gram.y"
{ localmode = YES; mode = IROHA_MODE_EmptyMode; } break;
case 45:
# line 189 "gram.y"
{ localmode = NO; } break;
case 46:
# line 192 "gram.y"
{ localmode = YES; 
			  mode = IROHA_MODE_ZenHiraKakuteiMode; } break;
case 47:
# line 195 "gram.y"
{ localmode = NO; } break;
case 48:
# line 198 "gram.y"
{ localmode = YES; 
			  mode = IROHA_MODE_ZenKataKakuteiMode; } break;
case 49:
# line 201 "gram.y"
{ localmode = NO; } break;
case 50:
# line 204 "gram.y"
{ localmode = YES; 
			  mode = IROHA_MODE_ZenAlphaKakuteiMode; } break;
case 51:
# line 207 "gram.y"
{ localmode = NO; } break;
case 52:
# line 210 "gram.y"
{ localmode = YES; 
			  mode = IROHA_MODE_HanKataKakuteiMode; } break;
case 53:
# line 213 "gram.y"
{ localmode = NO; } break;
case 54:
# line 216 "gram.y"
{ localmode = YES; 
			  mode = IROHA_MODE_HanAlphaKakuteiMode; } break;
case 55:
# line 219 "gram.y"
{ localmode = NO; } break;
case 56:
# line 222 "gram.y"
{ localmode = YES; 
			  mode = IROHA_MODE_AdjustBunsetsuMode; } break;
case 57:
# line 225 "gram.y"
{ localmode = NO; } break;
case 58:
# line 228 "gram.y"
{ changeModeName(IROHA_MODE_AlphaMode,yypvt[-0].ptr); } break;
case 59:
# line 230 "gram.y"
{ changeModeName(IROHA_MODE_EmptyMode,yypvt[-0].ptr); } break;
case 60:
# line 232 "gram.y"
{ changeModeName(IROHA_MODE_HexMode,yypvt[-0].ptr); } break;
case 61:
# line 234 "gram.y"
{ changeModeName(IROHA_MODE_BushuMode,yypvt[-0].ptr); } break;
case 62:
# line 236 "gram.y"
{ changeModeName(IROHA_MODE_EmptyMode,yypvt[-0].ptr); } break;
case 63:
# line 238 "gram.y"
{ changeModeName(IROHA_MODE_ZenHiraKakuteiMode,yypvt[-0].ptr); } break;
case 64:
# line 240 "gram.y"
{ changeModeName(IROHA_MODE_ZenKataKakuteiMode,yypvt[-0].ptr); } break;
case 65:
# line 242 "gram.y"
{ changeModeName(IROHA_MODE_ZenAlphaKakuteiMode,yypvt[-0].ptr); } break;
case 66:
# line 244 "gram.y"
{ changeModeName(IROHA_MODE_HanKataKakuteiMode,yypvt[-0].ptr); } break;
case 67:
# line 246 "gram.y"
{ changeModeName(IROHA_MODE_HanAlphaKakuteiMode,yypvt[-0].ptr); } break;
case 68:
# line 248 "gram.y"
{ changeModeName(IROHA_MODE_AdjustBunsetsuMode,yypvt[-0].ptr); } break;
case 69:
# line 250 "gram.y"
{ changeModeName(IROHA_MODE_KigoMode,yypvt[-0].ptr); } break;
case 70:
# line 252 "gram.y"
{ changeModeName(IROHA_MODE_JishuMode,yypvt[-0].ptr); } break;
case 71:
# line 254 "gram.y"
{ changeModeName(IROHA_MODE_TankouhoMode,yypvt[-0].ptr); } break;
case 72:
# line 256 "gram.y"
{ changeModeName(IROHA_MODE_IchiranMode,yypvt[-0].ptr); } break;
case 73:
# line 258 "gram.y"
{ changeModeName(IROHA_MODE_YesNoMode,yypvt[-0].ptr); } break;
case 74:
# line 260 "gram.y"
{ changeModeName(IROHA_MODE_ExtendMode,yypvt[-0].ptr); } break;
case 75:
# line 262 "gram.y"
{ changeModeName(IROHA_MODE_RussianMode,yypvt[-0].ptr); } break;
case 76:
# line 264 "gram.y"
{ changeModeName(IROHA_MODE_GreekMode,yypvt[-0].ptr); } break;
case 77:
# line 266 "gram.y"
{ changeModeName(IROHA_MODE_LineMode,yypvt[-0].ptr); } break;
case 78:
# line 268 "gram.y"
{ changeModeName(IROHA_MODE_ChangingServerMode,yypvt[-0].ptr); } break;
case 79:
# line 270 "gram.y"
{ changeModeName(IROHA_MODE_HenkanMethodMode,yypvt[-0].ptr); } break;
case 80:
# line 272 "gram.y"
{ changeModeName(IROHA_MODE_DeleteDicMode,yypvt[-0].ptr); } break;
case 81:
# line 274 "gram.y"
{ changeModeName(IROHA_MODE_TourokuMode,yypvt[-0].ptr); } break;
case 82:
# line 276 "gram.y"
{ changeModeName(IROHA_MODE_TourokuHinshiMode,yypvt[-0].ptr); } break;
case 83:
# line 278 "gram.y"
{ changeModeName(IROHA_MODE_TourokuDicMode,yypvt[-0].ptr); } break;
case 84:
# line 280 "gram.y"
{ changeModeName(IROHA_MODE_QuotedInsertMode,yypvt[-0].ptr); } break;
case 85:
# line 282 "gram.y"
{ changeModeName(IROHA_MODE_BubunMuhenkanMode,yypvt[-0].ptr); } break;
case 86:
# line 284 "gram.y"
{ changeModeName(IROHA_MODE_ZenKataHenkanMode,yypvt[-0].ptr); } break;
case 87:
# line 286 "gram.y"
{ changeModeName(IROHA_MODE_HanKataHenkanMode,yypvt[-0].ptr); } break;
case 88:
# line 288 "gram.y"
{ changeModeName(IROHA_MODE_ZenAlphaHenkanMode,yypvt[-0].ptr); } break;
case 89:
# line 290 "gram.y"
{ changeModeName(IROHA_MODE_HanAlphaHenkanMode,yypvt[-0].ptr); } break;
case 90:
# line 292 "gram.y"
{ changeModeName(IROHA_MODE_MountDicMode,yypvt[-0].ptr); } break;
case 91:
# line 295 "gram.y"
{ yyval.num = IROHA_MODE_HenkanMode; } break;
case 92:
# line 296 "gram.y"
{ yyval.num = IROHA_MODE_ZenHiraHenkanMode; } break;
case 93:
# line 297 "gram.y"
{ yyval.num = IROHA_MODE_ZenKataHenkanMode; } break;
case 94:
# line 298 "gram.y"
{ yyval.num = IROHA_MODE_HanKataHenkanMode; } break;
case 95:
# line 299 "gram.y"
{ yyval.num = IROHA_MODE_ZenAlphaHenkanMode; } break;
case 96:
# line 300 "gram.y"
{ yyval.num = IROHA_MODE_HanAlphaHenkanMode; } break;
case 97:
# line 301 "gram.y"
{ yyval.num = IROHA_MODE_ZenHiraKakuteiMode; } break;
case 98:
# line 302 "gram.y"
{ yyval.num = IROHA_MODE_ZenKataKakuteiMode; } break;
case 99:
# line 303 "gram.y"
{ yyval.num = IROHA_MODE_ZenAlphaKakuteiMode;} break;
case 100:
# line 304 "gram.y"
{ yyval.num = IROHA_MODE_HanKataKakuteiMode; } break;
case 101:
# line 305 "gram.y"
{ yyval.num = IROHA_MODE_HanAlphaKakuteiMode;} break;
case 102:
# line 306 "gram.y"
{ yyval.num = IROHA_MODE_AlphaMode; } break;
case 106:
# line 315 "gram.y"
{ 
				  if (yypvt[-0].ptr) {
				    ptr = (char*)malloc(strlen(yypvt[-0].ptr) +1);
				    strcpy(ptr, yypvt[-0].ptr);
				    RemoveDblQuote(ptr);
				    yyval.ptr = ptr;
				  }
				  else {
				    yyval.ptr = (char *)0;
				  }
				} break;
case 115:
# line 345 "gram.y"
{ if (i == 1 && j== 1) {
			    if (special == NO) {
			      chgKeyfunc((int)keybuff[0],(int)actbuff[0]);
			    }
			  }	
			  else {
			    actbuff[i] = 0;
			    keybuff[j] = 255;
			    if (j > 1) {
			      chgKeyfunc((int)keybuff[0],IROHA_FN_UseOtherKeymap);
			    }
			    else {
			      chgKeyfunc((int)keybuff[0],IROHA_FN_FuncSequence);
			    }
                          }
			  special = NO;
			  i = 0;
			  j = 0;
			} break;
case 118:
# line 369 "gram.y"
{
		       if (special == NEXTK && i == 1 && j == 0) {
			 chgKeyfunc(yypvt[-0].num, IROHA_FN_Next);
			 changeKeyfunc(IROHA_MODE_IchiranMode,
			 yypvt[-0].num, IROHA_FN_Forward,NULL,NULL);
		       }
		       if (special == PREVK && i == 1 && j == 0){
			 chgKeyfunc(yypvt[-0].num, IROHA_FN_Prev);
			 changeKeyfunc(IROHA_MODE_IchiranMode,
			      yypvt[-0].num, IROHA_FN_Backward,NULL,NULL);
		       }
                       keybuff[j++] = yypvt[-0].num;
		      } break;
case 119:
# line 382 "gram.y"
{ keybuff[j++] = yypvt[-0].num; } break;
case 120:
# line 385 "gram.y"
{ actbuff[i++] = IROHA_FN_Forward; } break;
case 121:
# line 386 "gram.y"
{ actbuff[i++] = IROHA_FN_Backward; } break;
case 122:
# line 387 "gram.y"
{ actbuff[i++] = IROHA_FN_Next; } break;
case 123:
# line 388 "gram.y"
{ actbuff[i++] = IROHA_FN_Prev; } break;
case 124:
# line 390 "gram.y"
{ actbuff[i++] = IROHA_FN_BeginningOfLine; } break;
case 125:
# line 391 "gram.y"
{ actbuff[i++] = IROHA_FN_EndOfLine; } break;
case 126:
# line 392 "gram.y"
{ actbuff[i++] = IROHA_FN_DeleteNext; } break;
case 127:
# line 394 "gram.y"
{ actbuff[i++] = IROHA_FN_DeletePrevious; } break;
case 128:
# line 396 "gram.y"
{ actbuff[i++] = IROHA_FN_KillToEndOfLine; } break;
case 129:
# line 397 "gram.y"
{ actbuff[i++] = IROHA_FN_Henkan; } break;
case 130:
# line 398 "gram.y"
{ actbuff[i++] = IROHA_FN_Kakutei; } break;
case 131:
# line 399 "gram.y"
{ actbuff[i++] = IROHA_FN_Shrink; } break;
case 132:
# line 400 "gram.y"
{ actbuff[i++] = IROHA_FN_Extend; } break;
case 133:
# line 401 "gram.y"
{ actbuff[i++] = IROHA_FN_AdjustBunsetsu; } break;
case 134:
# line 402 "gram.y"
{ actbuff[i++] = IROHA_FN_Quit; } break;
case 135:
# line 403 "gram.y"
{ actbuff[i++] = IROHA_FN_FunctionalInsert; } break;
case 136:
# line 404 "gram.y"
{ actbuff[i++] = IROHA_FN_QuotedInsert; } break;
case 137:
# line 405 "gram.y"
{ actbuff[i++] = IROHA_FN_ExtendMode; } break;
case 138:
# line 406 "gram.y"
{ actbuff[i++] = IROHA_FN_ExtendMode; } break;
case 139:
# line 408 "gram.y"
{ actbuff[i++] = IROHA_FN_Next; } break;
case 140:
# line 410 "gram.y"
{ actbuff[i++] = IROHA_FN_Prev; } break;
case 141:
# line 411 "gram.y"
{ actbuff[i++] = IROHA_FN_ConvertAsHex; } break;
case 142:
# line 413 "gram.y"
{ actbuff[i++] = IROHA_FN_ConvertAsBushu; } break;
case 143:
# line 415 "gram.y"
{ actbuff[i++] = IROHA_FN_Zenkaku; } break;
case 144:
# line 417 "gram.y"
{ actbuff[i++] = IROHA_FN_Hankaku; } break;
case 145:
# line 419 "gram.y"
{ actbuff[i++] = IROHA_FN_ToUpper; } break;
case 146:
# line 421 "gram.y"
{ actbuff[i++] = IROHA_FN_Capitalize; } break;
case 147:
# line 423 "gram.y"
{ actbuff[i++] = IROHA_FN_ToLower; } break;
case 148:
# line 425 "gram.y"
{ actbuff[i++] = IROHA_FN_DeletePrevious; } break;
case 149:
# line 428 "gram.y"
{ 
			 if (localmode == YES) {
			    if (mode == IROHA_MODE_IchiranMode) {
			       actbuff[i++] = IROHA_FN_Forward;
			    }
			    else {
			       actbuff[i++] = IROHA_FN_Next;
			    }
		 	   }
			 else {
			    actbuff[i++] = IROHA_FN_Next;
			    special = NEXTK;
			 }
		        } break;
case 150:
# line 444 "gram.y"
{ 
			 if (localmode == YES) {
			    if (mode == IROHA_MODE_IchiranMode) {
			       actbuff[i++] = IROHA_FN_Backward;
			    }
			    else {
			       actbuff[i++] = IROHA_FN_Prev;
			    }
			 }
			 else {
			    actbuff[i++] = IROHA_FN_Prev;
                            special = PREVK;
		         }
			} break;
case 151:
# line 459 "gram.y"
{ actbuff[i++] = IROHA_FN_KouhoIchiran; } break;
case 152:
# line 461 "gram.y"
{ actbuff[i++] = IROHA_FN_BubunMuhenkan; } break;
case 153:
# line 464 "gram.y"
{ actbuff[i++] = IROHA_FN_Next; } break;
case 154:
# line 467 "gram.y"
{ actbuff[i++] = IROHA_FN_Prev; } break;
case 155:
# line 470 "gram.y"
{ actbuff[i++] = IROHA_FN_BeginningOfLine; } break;
case 156:
# line 472 "gram.y"
{ actbuff[i++] = IROHA_FN_EndOfLine; } break;
case 157:
# line 474 "gram.y"
{ actbuff[i++] = IROHA_FN_AlphaMode; } break;
case 158:
# line 476 "gram.y"
{ actbuff[i++] = IROHA_FN_JapaneseMode; } break;
case 159:
# line 478 "gram.y"
{ actbuff[i++] = IROHA_FN_HexMode; } break;
case 160:
# line 480 "gram.y"
{ actbuff[i++] = IROHA_FN_BushuMode; } break;
case 161:
# line 482 "gram.y"
{ actbuff[i++] = IROHA_FN_KigouMode; } break;
case 162:
# line 485 "gram.y"
{ actbuff[i++] = IROHA_FN_HenkanNyuryokuMode; } break;
case 163:
# line 488 "gram.y"
{ actbuff[i++] = IROHA_FN_ZenHiraKakuteiMode; } break;
case 164:
# line 491 "gram.y"
{ actbuff[i++] = IROHA_FN_ZenKataKakuteiMode; } break;
case 165:
# line 494 "gram.y"
{ actbuff[i++] = IROHA_FN_HanKataKakuteiMode; } break;
case 166:
# line 497 "gram.y"
{ actbuff[i++] = IROHA_FN_ZenAlphaKakuteiMode; } break;
case 167:
# line 500 "gram.y"
{ actbuff[i++] = IROHA_FN_HanAlphaKakuteiMode; } break;
case 168:
# line 501 "gram.y"
{ actbuff[i++] = IROHA_FN_Hiragana; } break;
case 169:
# line 502 "gram.y"
{ actbuff[i++] = IROHA_FN_Katakana; } break;
case 170:
# line 503 "gram.y"
{ actbuff[i++] = IROHA_FN_Romaji; } break;
	}
	goto yystack;		/* reset registers in driver code */
}
