#include	"uni.h"
#include	"dafs.h"
#include "string.h"


short *
i_Str2Ucs(char * s, short * ucs)
{
	int len;
	int i;

	len = strlen(s);
	for(i=0;i<len;i++)
	    ucs[i] = (short) s[i];

	ucs[len] = (short) '\0';

	return ucs;
}

int
i_FindUniSlot(Table *t, short c, int start, int end)
{
	int si;
	int ei;
	int mi;
	int midpoint;

	si = t[start].index;
	ei = t[end].index;

	if(si > c || ei < c) return -1;

	if(si == c) return start;
	if(ei == c) return end;
	if(end == start + 1) return -1;

	mi = t[midpoint = ((start + end) >> 1)].index;

	if(mi < c) return i_FindUniSlot(t, c, midpoint, end);
	else return i_FindUniSlot(t, c, start, midpoint);
}
	
char *
i_Uc2Str(short s)
{
   int index;
	static char string[MAXUNILENGTH + 2];

        index = i_FindUniSlot(uni_table, s, 0, MAXUNIVALUE);
        if(index < 0) strcpy(string,"NO UNICODE ");
        else {
	    strcpy(string, uni_table[index].name);
       	    if(s > MAXASCII) strcat(string," ");
	}
    	return string;
}
    
char *
i_Ucs2Str(short * s, char * string)
{
    int i;
    unsigned long ucslength;

    ucslength = ucslen((const unsigned short*)s);
    string[0] = (short) 0;

    string[0] = 0;
    for(i=0;i<ucslength;i++)
	strcat(string,i_Uc2Str(s[i]));

    return string;
}
