
/*
 * Copyright (c) 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

/* 
// whacky thunking stuff for windows
*/

#include "rafport.h"

#define RUTILSTART 0
#define DAFSTART 1000
#define FORMSTART 2000

#if defined(W32SUT_16) || defined(W32SUT_32)
#include <windows.h>
#ifdef W32SUT_16
#include <windowsx.h>
#endif
#include <w32sut.h>
#include "smemory.h"
#include "rafio.h"
#include "rafutil.h"

#ifdef W32SUT_16
extern int FAR t1[];
extern int FAR t12[];
extern int FAR t123[];       
extern int FAR t1234[];  
extern int FAR t125[];
extern int FAR t13[];
extern int FAR t2[];      
extern int FAR t23[];
extern int FAR t234[];    
extern int FAR t2345[];
extern int FAR t245[];    
extern int FAR t24[];
extern int FAR t25[];          
extern int FAR t235[];          
extern int FAR t3[];                          
extern int FAR t34[];
extern int FAR t345[];
extern int FAR t456[]; 
extern int FAR t1356[]; 
extern int FAR t1345[]; 
extern int FAR t135[]; 
extern int FAR t136[]; 
extern int FAR t4[];                      
extern int FAR t5[];
#endif

DWORD thunkIt(int Fnc, int *thunks, DWORD Args[]);
DWORD CBThunkIt(DWORD Args[],int Fnc);

DWORD s_Switch(LPDWORD lp,DWORD dwFunc);
DWORD i_Switch(LPDWORD lp,DWORD dwFunc);
DWORD f_Switch(LPDWORD lp,DWORD dwFunc);

DWORD s_CSwitch(LPDWORD lp,DWORD dwFunc);
DWORD i_CSwitch(LPDWORD lp,DWORD dwFunc);
DWORD f_CSwitch(LPDWORD lp,DWORD dwFunc);

#endif
