#include "rafport.h"

#include <X11/Xlib.h>
#include <Xm/Xm.h>

#include "TestCanvas.h"

TestCanvas::TestCanvas(ScrollWindow *input_sw,
					   XtAppContext input_app_context,
					   Widget input_parent,
					   int input_w,
					   int input_h,
					   KeyMap **input_km)
 : Canvas(input_sw, input_app_context, input_parent, 0, input_w, input_h),
   km(input_km) 
{
}

TestCanvas::~TestCanvas()
{
}

KeyMap *TestCanvas::getKM() 
{ 
  return *km; 
}

