
/*
 * Copyright (c) 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _rafios_h_
#define _rafios_h_

/*
// This code was designed to get around the 64 k limit under windows
// I am not sure it is used anymore
*/

#if defined(SYS_OS_WIN16) || defined(MAVERICK)

int4 streamRead(char HUGEPTR *ptr, int4 size, int4 nitems, RafFile handle);
int4 streamWrite(const char HUGEPTR *ptr, int4 size, int4 nitems, RafFile handle);
RafFile streamOpen(const char *filename, const char *type);
int4 streamClose(RafFile handle);
int4 streamGetc(RafFile handle);
char *streamGets(char HUGEPTR *s, int4 size, RafFile handle);
int4 streamSeek(RafFile handle, long offset, int4 whence);
long streamTell(RafFile handle);
int4 streamEof(RafFile handle);
int4 streamPuts(char HUGEPTR *s, RafFile handle);

#endif

#endif
