
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include "TextView.h"
#include "illum.h"
#include "TextFrame.h"

//bogus
TextView::TextView(MainWindow *input_mw, iEntityPtr input_entity)
	: View(input_mw)
{
	this->createFrames(input_entity);
}

TextView::~TextView()
{
	int foo;
	
	foo = foo;
}

// bogus
void
TextView::createFrames(iEntityPtr entity)
{
	this->the_frame = new TextFrame(this, "1", entity);
	this->addFrame(this->the_frame);
}

void
TextView::configure()
{
	if (the_frame)
		the_frame->configure();
}

static char bogus_name[] = "Text";

aString
TextView::getName()
{
	return bogus_name;
}

ViewType
TextView::getMode()
{
	return vtTYPE;
}

void
TextView::addNewEntity(iEntityPtr entity)
{
	this->the_frame->addNewEntity(entity);
}


void
TextView::centerOnSelected(iEntityPtr entity)
{
	// bogus, find the frame
	// I'm on not the current frame
	
	TextFrame *frame;
	frame = this->the_frame;
	frame->centerOnSelected(entity);
}
